﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Annabooks.MCP3002;
using System.Threading;


namespace SPIADC2
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        MCP3002 myADC;
#pragma warning disable CS8618 // Non-nullable field must contain a non-null value when exiting constructor. Consider declaring as nullable.
        public MainWindow()
#pragma warning restore CS8618 // Non-nullable field must contain a non-null value when exiting constructor. Consider declaring as nullable.
        {
            InitializeComponent();
            Thread adcStartup = new Thread(new ThreadStart(ADCSetup));
            adcStartup.Start();
        }

        private void ADCSetup()
        {
            myADC = new MCP3002("SPI2", 8000000, 0, false);
            Thread.Sleep(1000);
            if (myADC.MCP3002Status())
            {
                Application.Current.Dispatcher.Invoke((Action)(() => txtStatus.Text = "ADC is Ready"));
            }
            else
            {
                Application.Current.Dispatcher.Invoke((Action)(() => txtStatus.Text = "ADC is NOT Ready: " + myADC.connectionError));
            }
        }

        private void btnReadChannel0_Click(object sender, RoutedEventArgs e)
        {
            if (myADC.MCP3002Status())
            {
                txtChannel0Result.Text = Math.Round((double)myADC.ReadChannel0() / 1024 * 3.3, 2).ToString();
            }

        }

        private void btnReadChannel1_Click(object sender, RoutedEventArgs e)
        {
            if (myADC.MCP3002Status())
            {
                txtChannel1Result.Text = Math.Round((double)myADC.ReadChannel1() / 1024 * 3.3, 2).ToString();
            }

        }

        private void btnCh0PCh1N_Click(object sender, RoutedEventArgs e)
        {
            if (myADC.MCP3002Status())
            {
                txtChannelDiff.Text = Math.Round((double)myADC.ReadDiff() / 1024 * 3.3, 2).ToString();
            }

        }
    }
}
